'Mod Launch Script
'Based on Bonescythe, FoxBat and Myhrginoc's MOD LAUNCHER Script
'Updated by E-R 7/20/09
'This script will launch a mod in a Diablo II subdirectory.
'  
Dim ErrorFlag
Dim PlugY
Dim PlugYErrorFlag
Dim Txt
'Create a shell object
Set Shell = WScript.CreateObject("WScript.Shell")
'Create a file system object
Set FSO = WScript.CreateObject("Scripting.FileSystemObject")
'Get path to Diablo II EXE from registry
Reg1 = "HKCU\Software\Blizzard Entertainment\Diablo II"
Reg2 = "HKLM\Software\Blizzard Entertainment\Diablo II"
Reg1Use = True
Reg2Use = True
'Ensure script gets to clean up if setting up and launching the mod fails
On Error Resume Next
D2Path = Shell.RegRead(Reg1 & "\InstallPath")& "\"
If (FSO.FileExists(D2Path & "Diablo II.exe") = 0) Then
  Reg1Use = False
End If
VanillaSave1 = D2Path & "save\"
D2Path = Shell.RegRead(Reg2 & "\InstallPath")& "\"
If (FSO.FileExists(D2Path & "Diablo II.exe") = 0) Then
  Reg2Use = False
End If
VanillaSave2 = D2Path & "save\"
If Reg1Use = False Then
  If Reg2Use = False Then
    D2Alert = "Diablo IIɃCXg[Ă܂BDiablo IIăCXg[ĉB"
    D2Choose = MsgBox (D2Alert,16,"Launch Failure")
    On Error GoTo 0
    WScript.Quit(1)
  End If
End If
'Get the current directory folder object
Set Folder = FSO.GetFolder(".")
'Include ini file
If FSO.FileExists(Folder.Path & "\MLS.ini") Then
  Set inifile = FSO.OpenTextFile(Folder.Path & "\MLS.ini",1,False)
  ini = inifile.ReadAll
  Execute ini
Else
  Backup = "0"
  Command = ""
  Bin = "0"
  DLog = "0"
  Dump = "0"
End If
'Check for game running mode
If FSO.FolderExists(Folder.Path & "\data\global\excel") Then
  Txt = 1
  TxtPath = Folder.Path & "\data\global\excel"
  BinFiles = TxtPath & "\*.bin"
  FSO.DeleteFile(BinFiles)
  Err.Clear
Else
  Txt = 0
End If
'Check for installation of PlugY, The Survival Kit in Diablo installation directory
If FSO.FileExists(Folder.Path & "\PlugY.ini") Then
  PlugY = 1
Else
  PlugY = 0
End If
'Check for proper installation of Blizzard DLLs in Diablo installation directory
ErrorFlag = 0
PlugYErrorFlag = 0
Set BNClientDLL = FSO.GetFile(D2Path & "Bnclient.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set ClientDLL = FSO.GetFile(D2Path & "D2Client.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set CmpDLL = FSO.GetFile(D2Path & "D2CMP.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set CommonDLL = FSO.GetFile(D2Path & "D2Common.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set Direct3dDLL = FSO.GetFile(D2Path & "D2Direct3D.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set DDRawDLL = FSO.GetFile(D2Path & "D2DDraw.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set GameDLL = FSO.GetFile(D2Path & "D2Game.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set GdiDLL = FSO.GetFile(D2Path & "D2Gdi.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set GfxDLL = FSO.GetFile(D2Path & "D2Gfx.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set GlideDLL = FSO.GetFile(D2Path & "D2Glide.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set LangDLL = FSO.GetFile(D2Path & "D2Lang.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set LaunchDLL = FSO.GetFile(D2Path & "D2Launch.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set MCPClientDLL = FSO.GetFile(D2Path & "D2MCPClient.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set MultiDLL = FSO.GetFile(D2Path & "D2Multi.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set NetDLL = FSO.GetFile(D2Path & "D2Net.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set SoundDLL = FSO.GetFile(D2Path & "D2Sound.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set WinDLL = FSO.GetFile(D2Path & "D2Win.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set FogDLL = FSO.GetFile(D2Path & "Fog.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
Set StormDLL = FSO.GetFile(D2Path & "Storm.dll")
If Err.Number > 0 Then
  ErrorFlag = ErrorFlag + 1
  Err.Clear
End If
If PlugY = 1 Then
  If FSO.FileExists(D2Path & "PlugY.dll") Then
    Set PlugYDLL = FSO.GetFile(D2Path & "PlugY.dll")
    If FSO.FolderExists(D2Path & "PlugY") Then
    Else
      PlugYErrorFlag = PlugYErrorFlag + 1
    End If
  Else
    If FSO.FileExists(Folder.Path & "\PlugY.dll") Then
      PlugY = 2
    Else
      If FSO.FileExists(D2Path & "PlugY.baq") Then
        ErrorFlag = ErrorFlag + 1
      Else
        PlugYErrorFlag = PlugYErrorFlag + 1
      End If
    End If
    If FSO.FolderExists(Folder.Path & "\PlugY") Then
    Else
      PlugYErrorFlag = PlugYErrorFlag + 1
    End If
  End If
End If
If ErrorFlag > 0 Then
  D2Alert = "Diablo IItH_dllt@C݂ȂAOύXĂ܂B" & chr(13) & chr(10) & chr(10) & "recover.vbssɍēxsĉB"
  D2Choose = MsgBox (D2Alert,16,"Launch Failure")
  WScript.Quit(2)
End If
If PlugYErrorFlag > 0 Then
  D2Alert = "PlugYgp邽߂ɕKvȃt@C݂܂B" & chr(13) & chr(10) & chr(10) & "PlugYɃCXg[Ă邩mFĉB"
  D2Choose = MsgBox (D2Alert,16,"Launch Failure")
  WScript.Quit(3)
End If
'If Diablo path is not the current directory run MOD otherwise just fix up
If Folder.Path & "\" <> D2Path Then
  'Get full pathname of current directory and append save dir name
  Dir = Folder.Path & "\save\"
  'Make new save dir if necessary
  If (FSO.FolderExists(Dir) = False) then
    Set f = FSO.CreateFolder(Dir)
    If Err.Number > 0 Then
      D2Alert = "savetH_쐬ł܂B蓮ō쐬ɍēxsĉB"
      D2Choose = MsgBox (D2Alert,16,"Launch Failure")
      WScript.Quit(4)
    End If
  End If
  'Backup to save dir
  If Backup = "1" Then
    BDir = Folder.Path & "\save\backup\"
    If (FSO.FolderExists(BDir) = False) then
      Set f = FSO.CreateFolder(BDir)
      If Err.Number > 0 Then
        D2Alert = "backuptH_쐬ł܂B蓮ō쐬ɍēxsĂB"
        D2Choose = MsgBox (D2Alert,16,"Launch Failure")
        WScript.Quit(5)
      End If
    End If
    SaveData = Dir & "*.*"
    FSO.CopyFile Savedata,BDir
  End If
  'Determine game running mode
  If Txt = 1 Then
    D2CmdLine = chr(34) & D2Path & "Game.exe" & chr(34) & Command & " -direct -txt -w"
  Else
    D2CmdLine = chr(34) & D2Path & "Game.exe" & chr(34) & Command & " -direct -w"
  End If
  'Hide Blizzard DLLs!
  'Check if BNClient.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\BNClient.dll") Then
    BNClientDLL.Move (D2Path & "BNClient.baq")
  End If
  'Check if D2Client.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Client.dll") Then
    ClientDLL.Move (D2Path & "D2Client.baq")
  End If
  'Check if D2CMP.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2CMP.dll") Then
    CmpDLL.Move (D2Path & "D2CMP.baq")
  End If
  'Check if D2Common.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Common.dll") Then
    CommonDLL.Move (D2Path & "D2Common.baq")
  End If
  'Check if D2Direct3D.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Direct3D.dll") Then
    Direct3dDLL.Move (D2Path & "D2Direct3D.baq")
  End If
  'Check if D2DDraw.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2DDraw.dll") Then
    DDrawDLL.Move (D2Path & "D2DDraw.baq")
  End If
  'Check if D2Game.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Game.dll") Then
    GameDLL.Move (D2Path & "D2Game.baq")
  End If
  'Check if D2Gdi.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Gdi.dll") Then
    GdiDLL.Move (D2Path & "D2Gdi.baq")
  End If
  'Check if D2Gfx.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Gfx.dll") Then
    GfxDLL.Move (D2Path & "D2Gfx.baq")
  End If
  'Check if D2Glide.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Glide.dll") Then
    GlideDLL.Move (D2Path & "D2Glide.baq")
  End If
  'Check if D2Lang.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Lang.dll") Then
    LangDLL.Move (D2Path & "D2Lang.baq")
  End If
  'Check if D2Launch.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Launch.dll") Then
    LaunchDLL.Move (D2Path & "D2Launch.baq")
  End If
  'Check if D2MCPClient.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2MCPClient.dll") Then
    MCPClientDLL.Move (D2Path & "D2MCPClient.baq")
  End If
  'Check if D2Multi.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Multi.dll") Then
    MultiDLL.Move (D2Path & "D2Multi.baq")
  End If
  'Check if D2Net.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Net.dll") Then
    NetDLL.Move (D2Path & "D2Net.baq")
  End If
  'Check if D2Sound.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Sound.dll") Then
    SoundDLL.Move (D2Path & "D2Sound.baq")
  End If
  'Check if D2Win.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\D2Win.dll") Then
    WinDLL.Move (D2Path & "D2Win.baq")
  End If
  'Check if Fog.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\Fog.dll") Then
    FogDLL.Move (D2Path & "Fog.baq")
  End If
  'Check if Storm.dll exists in the current directory
  If FSO.FileExists(Folder.Path & "\Storm.dll") Then
    StormDLL.Move (D2Path & "Storm.baq")
  End If
  'Check if PlugY.dll exists in the current directory
  If PlugY = 1 Then
    If FSO.FileExists(Folder.Path & "\PlugY.dll") Then
      PlugYDLL.Move (D2Path & "PlugY.baq")
    End If
  End If
  'Get mod save folder and write new save path to the Registry
  If Reg1Use Then
    RegSave = Reg1 & "\Save Path"
    Shell.RegWrite RegSave, Dir, "REG_SZ"
  End If
  If Reg2Use Then
    RegSave = Reg2 & "\Save Path"
    Shell.RegWrite RegSave, Dir, "REG_SZ"
  End If
  'Launch Diablo II normally and wait for it to finish
  Result = Shell.Run(D2CmdLine, 1, TRUE)
  'Restore name to Blizzard's BNClient.dll
  If BNClientDLL.Name = "BNClient.baq" Then
    BNClientDLL.Move (D2Path & "BNClient.dll")
  End If
  'Restore name to Blizzard's D2Client.dll
  If ClientDLL.Name = "D2Client.baq" Then
    ClientDLL.Move (D2Path & "D2Client.dll")
  End If
  'Restore name to Blizzard's D2CMP.dll
  If CmpDLL.Name = "D2CMP.baq" Then
    CmpDLL.Move (D2Path & "D2CMP.dll")
  End If
  'Restore name to Blizzard's D2Common.dll
  If CommonDLL.Name = "D2Common.baq" Then
    CommonDLL.Move (D2Path & "D2Common.dll")
  End If
  'Restore name to Blizzard's D2Direct3D.dll
  If Direct3dDLL.Name = "D2Direct3D.baq" Then
    Direct3dDLL.Move (D2Path & "D2Direct3D.dll")
  End If
  'Restore name to Blizzard's D2DDraw.dll
  If DDrawDLL.Name = "D2DDraw.baq" Then
    DDrawDLL.Move (D2Path & "D2DDraw.dll")
  End If
  'Restore name to Blizzard's D2Game.dll
  If GameDLL.Name = "D2Game.baq" Then
    GameDLL.Move (D2Path & "D2Game.dll")
  End If
  'Restore name to Blizzard's D2Gdi.dll
  If GdiDLL.Name = "D2Gdi.baq" Then
    GdiDLL.Move (D2Path & "D2Gdi.dll")
  End If
  'Restore name to Blizzard's D2Gfx.dll
  If GfxDLL.Name = "D2Gfx.baq" Then
    GfxDLL.Move (D2Path & "D2Gfx.dll")
  End If
  'Restore name to Blizzard's D2Glide.dll
  If GlideDLL.Name = "D2Glide.baq" Then
    GlideDLL.Move (D2Path & "D2Glide.dll")
  End If
  'Restore name to Blizzard's D2Lang.dll
  If LangDLL.Name = "D2Lang.baq" Then
    LangDLL.Move (D2Path & "D2Lang.dll")
  End If
  'Restore name to Blizzard's D2Launch.dll
  If LaunchDLL.Name = "D2Launch.baq" Then
    LaunchDLL.Move (D2Path & "D2Launch.dll")
  End If
  'Restore name to Blizzard's D2MCPClient.dll
  If MCPClientDLL.Name = "D2MCPClient.baq" Then
    MCPClientDLL.Move (D2Path & "D2MCPClient.dll")
  End If
  'Restore name to Blizzard's D2Multi.dll
  If MultiDLL.Name = "D2Multi.baq" Then
    MultiDLL.Move (D2Path & "D2Multi.dll")
  End If
  'Restore name to Blizzard's D2Net.dll
  If NetDLL.Name = "D2Net.baq" Then
    NetDLL.Move (D2Path & "D2Net.dll")
  End If
  'Restore name to Blizzard's D2Sound.dll
  If SoundDLL.Name = "D2Sound.baq" Then
    SoundDLL.Move (D2Path & "D2Sound.dll")
  End If
  'Restore name to Blizzard's D2Win.dll
  If WinDLL.Name = "D2Win.baq" Then
    WinDLL.Move (D2Path & "D2Win.dll")
  End If
  'Restore name to Blizzard's Fog.dll
  If FogDLL.Name = "Fog.baq" Then
    FogDLL.Move (D2Path & "Fog.dll")
  End If
  'Restore name to Blizzard's Storm.dll
  If StormDLL.Name = "Storm.baq" Then
    StormDLL.Move (D2Path & "Storm.dll")
  End If
  'Restore name to PlugY.dll
  If PlugY = 1 Then
    If PlugYDLL.Name = "PlugY.baq" Then
      PlugYDLL.Move (D2Path & "PlugY.dll")
    End If
  End If
  'Delete bin files
  If Txt = 1 Then
    If Bin <> "1" Then
      BinFiles = TxtPath & "\*.bin"
      FSO.DeleteFile(BinFiles)
    End If
  End If
  'Delete D*******.txt files
  If DLog <> "1" Then
    DTxtFiles = (D2Path & "D*.txt")
    FSO.DeleteFile(DTxtFiles)
  End If
  'Delete Crashdump files
  If Dump <> "1" Then
    Crashdump = (D2Path & "Crashdump")
    FSO.DeleteFile(Crashdump)
  End If
  'Restore previous save directory setting in registry
  If Reg1Use Then
    RegSave = Reg1 & "\Save Path"
    Shell.RegWrite RegSave, VanillaSave1, "REG_SZ"
  End If
  If Reg2Use Then
    RegSave = Reg2 & "\Save Path"
    Shell.RegWrite RegSave, VanillaSave2, "REG_SZ"
  End If
Else
  D2Alert = "̃XNvgDiablo IItH_ł͎sł܂B" & chr(13) & chr(10) & chr(10) & "eModtH_ŎsÃG[Ăꍇrecover.vbssĉB" & chr(13) & chr(10) & chr(10) & "WXg̐ݒ肪ɂȂĂ܂B"
  D2Choose = MsgBox (D2Alert,16,"Launch Failure")
  WScript.Quit(6)
End If
On Error GoTo 0
WScript.Quit(0)